
Eina_Bool _efl_ui_focus_manager_calc_register(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent, Efl_Ui_Focus_Manager *redirect);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_calc_register, Eina_Bool, 0, EFL_FUNC_CALL(child, parent, redirect), Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent, Efl_Ui_Focus_Manager *redirect);

Eina_Bool _efl_ui_focus_manager_calc_register_logical(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent, Efl_Ui_Focus_Manager *redirect);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_calc_register_logical, Eina_Bool, 0, EFL_FUNC_CALL(child, parent, redirect), Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent, Efl_Ui_Focus_Manager *redirect);

Eina_Bool _efl_ui_focus_manager_calc_update_redirect(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Manager *redirect);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_calc_update_redirect, Eina_Bool, 0, EFL_FUNC_CALL(child, redirect), Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Manager *redirect);

Eina_Bool _efl_ui_focus_manager_calc_update_parent(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent);

EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_calc_update_parent, Eina_Bool, 0, EFL_FUNC_CALL(child, parent), Efl_Ui_Focus_Object *child, Efl_Ui_Focus_Object *parent);

void _efl_ui_focus_manager_calc_unregister(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *child);

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_manager_calc_unregister, EFL_FUNC_CALL(child), Efl_Ui_Focus_Object *child);

Efl_Ui_Focus_Object *_efl_ui_focus_manager_calc_efl_ui_focus_manager_move(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Direction direction);


Efl_Ui_Focus_Object *_efl_ui_focus_manager_calc_efl_ui_focus_manager_request_move(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Direction direction, Efl_Ui_Focus_Object *child, Eina_Bool logical);


void _efl_ui_focus_manager_calc_efl_ui_focus_manager_manager_focus_set(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *focus);


Efl_Ui_Focus_Object *_efl_ui_focus_manager_calc_efl_ui_focus_manager_manager_focus_get(const Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


void _efl_ui_focus_manager_calc_efl_ui_focus_manager_redirect_set(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Manager *redirect);


Efl_Ui_Focus_Manager *_efl_ui_focus_manager_calc_efl_ui_focus_manager_redirect_get(const Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


Eina_Iterator *_efl_ui_focus_manager_calc_efl_ui_focus_manager_border_elements_get(const Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


Eina_Bool _efl_ui_focus_manager_calc_efl_ui_focus_manager_border_elements_changed_get(const Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


Eina_Iterator *_efl_ui_focus_manager_calc_efl_ui_focus_manager_viewport_elements_get(const Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Eina_Rect viewport);


Eina_Bool _efl_ui_focus_manager_calc_efl_ui_focus_manager_root_set(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *root);


Efl_Ui_Focus_Object *_efl_ui_focus_manager_calc_efl_ui_focus_manager_root_get(const Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


Efl_Ui_Focus_Object *_efl_ui_focus_manager_calc_efl_ui_focus_manager_request_subchild(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *root);


Efl_Ui_Focus_Relations *_efl_ui_focus_manager_calc_efl_ui_focus_manager_fetch(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Object *child);


Efl_Ui_Focus_Manager_Logical_End_Detail _efl_ui_focus_manager_calc_efl_ui_focus_manager_logical_end(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


void _efl_ui_focus_manager_calc_efl_ui_focus_manager_reset_history(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


void _efl_ui_focus_manager_calc_efl_ui_focus_manager_pop_history_stack(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


void _efl_ui_focus_manager_calc_efl_ui_focus_manager_setup_on_first_touch(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, Efl_Ui_Focus_Direction direction, Efl_Ui_Focus_Object *entry);


void _efl_ui_focus_manager_calc_efl_ui_focus_manager_dirty_logic_freeze(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


void _efl_ui_focus_manager_calc_efl_ui_focus_manager_dirty_logic_unfreeze(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


Efl_Object *_efl_ui_focus_manager_calc_efl_object_constructor(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


Efl_Object *_efl_ui_focus_manager_calc_efl_object_finalize(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


Efl_Object *_efl_ui_focus_manager_calc_efl_object_provider_find(const Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd, const Efl_Class *klass);


void _efl_ui_focus_manager_calc_efl_object_destructor(Eo *obj, Efl_Ui_Focus_Manager_Calc_Data *pd);


static Eina_Bool
_efl_ui_focus_manager_calc_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_FOCUS_MANAGER_CALC_EXTRA_OPS
#define EFL_UI_FOCUS_MANAGER_CALC_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_register, _efl_ui_focus_manager_calc_register),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_register_logical, _efl_ui_focus_manager_calc_register_logical),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_update_redirect, _efl_ui_focus_manager_calc_update_redirect),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_update_parent, _efl_ui_focus_manager_calc_update_parent),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_calc_unregister, _efl_ui_focus_manager_calc_unregister),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_move, _efl_ui_focus_manager_calc_efl_ui_focus_manager_move),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_request_move, _efl_ui_focus_manager_calc_efl_ui_focus_manager_request_move),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_focus_set, _efl_ui_focus_manager_calc_efl_ui_focus_manager_manager_focus_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_focus_get, _efl_ui_focus_manager_calc_efl_ui_focus_manager_manager_focus_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_redirect_set, _efl_ui_focus_manager_calc_efl_ui_focus_manager_redirect_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_redirect_get, _efl_ui_focus_manager_calc_efl_ui_focus_manager_redirect_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_border_elements_get, _efl_ui_focus_manager_calc_efl_ui_focus_manager_border_elements_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_border_elements_changed_get, _efl_ui_focus_manager_calc_efl_ui_focus_manager_border_elements_changed_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_viewport_elements_get, _efl_ui_focus_manager_calc_efl_ui_focus_manager_viewport_elements_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_root_set, _efl_ui_focus_manager_calc_efl_ui_focus_manager_root_set),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_root_get, _efl_ui_focus_manager_calc_efl_ui_focus_manager_root_get),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_request_subchild, _efl_ui_focus_manager_calc_efl_ui_focus_manager_request_subchild),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_fetch, _efl_ui_focus_manager_calc_efl_ui_focus_manager_fetch),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_logical_end, _efl_ui_focus_manager_calc_efl_ui_focus_manager_logical_end),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_reset_history, _efl_ui_focus_manager_calc_efl_ui_focus_manager_reset_history),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_pop_history_stack, _efl_ui_focus_manager_calc_efl_ui_focus_manager_pop_history_stack),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_setup_on_first_touch, _efl_ui_focus_manager_calc_efl_ui_focus_manager_setup_on_first_touch),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_dirty_logic_freeze, _efl_ui_focus_manager_calc_efl_ui_focus_manager_dirty_logic_freeze),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_dirty_logic_unfreeze, _efl_ui_focus_manager_calc_efl_ui_focus_manager_dirty_logic_unfreeze),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_ui_focus_manager_calc_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_finalize, _efl_ui_focus_manager_calc_efl_object_finalize),
      EFL_OBJECT_OP_FUNC(efl_provider_find, _efl_ui_focus_manager_calc_efl_object_provider_find),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_ui_focus_manager_calc_efl_object_destructor),
      EFL_UI_FOCUS_MANAGER_CALC_EXTRA_OPS
   );
   opsp = &ops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_focus_manager_calc_class_desc = {
   EO_VERSION,
   "Efl.Ui.Focus.Manager_Calc",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Ui_Focus_Manager_Calc_Data),
   _efl_ui_focus_manager_calc_class_initializer,
   _efl_ui_focus_manager_calc_class_constructor,
   _efl_ui_focus_manager_calc_class_destructor
};

EFL_DEFINE_CLASS(efl_ui_focus_manager_calc_class_get, &_efl_ui_focus_manager_calc_class_desc, EFL_OBJECT_CLASS, EFL_UI_FOCUS_MANAGER_INTERFACE, NULL);
